#pragma once
#include <iostream>
#include <gtkmm/window.h>
#include <gtkmm/button.h>
#include <gtkmm/picture.h>
#include <gtkmm/box.h>
#include <gtkmm/label.h>
#include <gtkmm/entry.h>
#include <gtkmm/singleselection.h>
#include <gtkmm/listview.h>
#include <gtkmm/signallistitemfactory.h>
#include <gtkmm/scrolledwindow.h>

#include <glibmm/ustring.h>
#include <glibmm/fileutils.h>

#include <gdkmm/pixbuf.h>
#include <gdkmm/texture.h>

#include <giomm/icon.h>
#include <giomm/liststore.h>

#include "VideoModel.hpp"
#include <YoutubeApi/youtubeapi.hpp>

namespace components {
    // Главное окно приложения
    class MainWindow : public Gtk::Window {
    public:
        MainWindow();
        ~MainWindow() override;

    protected:
        // --Обработка событий--
        // Клик кнопки
        void on_btn_clicked();
        // При создании элемента в m_video_list
        void onVideoSetup(const Glib::RefPtr<Gtk::ListItem>& list_item);
        // При записи данных в m_video_list
        void onVideoBind(const Glib::RefPtr<Gtk::ListItem>& list_item);

        // --Виджеты--
        Gtk::Box                m_layout;       // Главный контейнер
        // Поиск
        Gtk::Box                m_search_box;   // Панель поиска
        Gtk::Entry              m_search_field; // Поле ввода запроса
        Gtk::Button             m_search_btn;   // Кнопка поиска
        // Основное
        Gtk::Box                m_body;         // Главное
        Gtk::ScrolledWindow     m_video_scroll; // Окно прокрутки для видео
        Gtk::ListView           m_video_list;   // Список видео

        // --Общее--
        // Модель отображения видео
        Glib::RefPtr<Gio::ListStore<VideoModel>> m_video_storage;
        // Возвращает дочерний виджет для кнопок, которым нужны иконка с текстом
        Gtk::Box* getButtonContents(Glib::ustring text, std::string icon_name);
    };
}